Index: squid/src/HintCacheNodes.c
diff -u /dev/null squid/src/HintCacheNodes.c:1.1.2.2
--- /dev/null	Mon Jan 26 04:57:38 2004
+++ squid/src/HintCacheNodes.c	Mon May 20 19:46:41 2002
@@ -0,0 +1,970 @@
+/*
+ * $Date: 2004/08/17 20:55:13 $ $Id: squid-push-HEAD,v 1.1 2004/08/17 20:55:13 hno Exp $
+ *
+ * DEBUG: section 88    List of known caches.
+ * AUTHOR: Mike Dahlin, UT Austin, 1998
+ *
+ * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
+ * --------------------------------------------------------
+ *
+ *  Squid is the result of efforts by numerous individuals from the
+ *  Internet community.  Development is led by Duane Wessels of the
+ *  National Laboratory for Applied Network Research and funded by
+ *  the National Science Foundation.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *  
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *  
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *  
+ */
+/*
+ *------------------------------------------------------------------
+ * LESS Group 
+ * Computer Sciences Department 
+ * University of Texas at Austin
+ *
+ * HCNodelist ---
+ * The nodelist keeps a list of all nodes in the hierarchy whether they
+ * are alive or dead. It uses a flooding algorithm for this (see 
+ * ../notes.3.17.1998). As part of this flooding algorithm, it learns
+ * a hopcount to other nodes. We tell squid_db this hopcount as an
+ * initial *rough* estimate of distance between nodes.
+ *  
+ * The flooding algorithm needs as input a list of "neighbors". The lists
+ * of neighbors for all nodes MUST overlap. The lists of neighbors SHOULD
+ * include only nearby neighbors (so that the hopcounts are correct). 
+ * It uses the squid static hierarchy (see neighbors.c e.g. getFirstPeer()
+ * etc) for this initial list.
+ *------------------------------------------------------------------
+ */
+#include "squid.h"
+
+/*
+ * Mike Dahlin's interface comments from HCNodelist.h:
+ *
+ * Out-calls: These internal routines are where you should place
+ * outcalls for being notified of important events:
+ *
+ * static void HCNodelist_OutcallHops _PARAMS((struct sockaddr_in sin, 
+ *						int hops)); 
+ *
+ * e.g.  The nodelist promises to tell squid_db whenever it learns a new
+ *       distance to a node. ?? The nodelist promises to tell Plaxton
+ *       when the distance to a node changes??
+ *
+ * static void HCNodelist_OutcallJoin() _PARAMS((struct sockaddr_in sin));
+ * e.g.  The nodelist promises to tell Plaxton when a new node joins.
+ *
+ * static void hintCacheNodelist_OutcallLeave() _PARAMS((struct sockaddr_in sin));
+ *  The nodelist promises to tell Plaxton when a node leaves.
+ */
+
+#define HCNODES_DEBUG 88
+
+typedef struct HierNodeElem
+{
+    dlink_node links;
+    struct sockaddr_in sin;
+    int action;			/* HC_Join or HC_Leave */
+    long long timestamp_ns;	/* time of action */
+}
+HierNodeElem;
+
+static dlink_list nodes;
+static int myStatus = HC_Leave;
+
+static void HierNodeElem_Init _PARAMS((HierNodeElem *, struct sockaddr_in *,
+	int action, long long timestamp_ns));
+
+static HierNodeElem *nodeFind(struct sockaddr_in *sin);
+static long long currentTimeNS();
+static void floodEvent(int action, struct sockaddr_in *source,
+    long long timeNS, int hopcount);
+
+static void hintCacheNodelistOutcallHops(struct sockaddr_in *sin,
+    int hops, long long timeNS);
+static void hintCacheNodelistOutcallJoin(struct sockaddr_in *sin,
+    int hops, long long timeNS);
+static void hintCacheNodelistOutcallLeave(struct sockaddr_in *sin,
+    int hops, long long timeNS);
+
+static void printList();
+
+
+static void
+HierNodeElem_Init(HierNodeElem * e, struct sockaddr_in *sin, int action,
+    long long timestamp_ns)
+{
+    assert(action == HC_Join || action == HC_Leave);
+    List_InitElement(&e->links);
+    e->sin = *sin;
+    e->action = action;
+    e->timestamp_ns = timestamp_ns;
+}
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheNodeList_Init --
+ *
+ *          Constructor.
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      Initialize nodelist to empty list.
+ *
+ *----------------------------------------------3.31.1998-------------
+ */
+void
+hintCacheNodelistInit(void)
+{
+    nodes.head = nodes.tail = 0;
+}
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheNodeListDestroy --
+ *
+ *          Deallocate all elements in list
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *--------------------------------------------------3.31.1998-------
+ */
+void
+hintCacheNodelist_Destroy(void)
+{
+    dlink_node *item;
+    
+    while (nodes.head) {
+	item = nodes.head;
+	dlinkDelete(item, &nodes);
+	xfree(item);
+    }
+}
+
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheNodeListLocalJoin --
+ *
+ *          Do a local join. This tells the algorithm
+ *          to flood "join" messages to the neighbors.
+ *
+ * Arguments:
+ *      struct sockaddr_in myId -- my ip address
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *-----------------------------------------------------4.1.1998----
+ */
+void
+hintCacheNodelistLocalJoin(void)
+{
+    struct sockaddr_in *myId;
+    int hopcount;
+    long long timeNS;
+#if 0
+    HintCacheEntry hcEntry;
+    HintCacheUpdate update;
+    URLKey key;
+    int nbpl;
+    int ii;
+#endif
+
+    myStatus = HC_Join;
+
+    myId = &Config.Sockaddr.http->s;
+    timeNS = currentTimeNS();
+    hopcount = 1;
+    floodEvent(HC_Join, myId, timeNS, hopcount);
+
+#if 0
+    /* "Priming" code */
+    if (parentOutgoingA) {
+	nbpl = (hintCachePlax_bucketsPerLevel > 0) ? hintCachePlax_bucketsPerLevel : 256;
+	for (ii = 0; ii < nbpl; ii++) {
+	    key.key = ii;
+	    hintCacheEntry_Init(&hcEntry, key, &Config.Sockaddr.http->s);
+	    hintCacheUpdate_Init(&update, HC_InvalToParent, &hcEntry, 1);
+	    hcprop_handleInvalToParent(&update, 1);
+	}
+    }
+#endif
+}
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheNodeListLocalLeave --
+ *
+ *          Do a local leave. This tells the algorithm
+ *          to flood "leave" messages to the neighbors.
+ *
+ * Arguments:
+ *      struct sockaddr_in myId -- my ip address
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *-----------------------------------------------------4.1.1998----
+ */
+void
+hintCacheNodelistLocalLeave(void)
+{
+    struct sockaddr_in *myId;
+    int hopcount;
+    long long timeNS;
+
+    myStatus = HC_Leave;
+    myId = &Config.Sockaddr.http->s;
+    timeNS = currentTimeNS();
+    hopcount = 1;
+    floodEvent(HC_Leave, myId, timeNS, hopcount);
+}
+
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheNodelistgetMyStatus --
+ *
+ *          Am I currently in or out?
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *----------------------------------------------------4.1.1998--------
+ */
+int
+hintCacheNodelistmyStatus(void)
+{
+    return myStatus;
+}
+
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheNodelistNetJoin --
+ *
+ *          Process a "join" received from the network.
+ *          If this is a new node, a new action for a node,
+ *          or a current action with a shorter distance,
+ *          proceed with the join and propagate message
+ *          to neighbors.
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      Allocates and adds an element to the list; calls 
+ *      OutcallJoin().
+ *
+ *------------------------------------------------------7.19.1998----
+ */
+void
+hintCacheNodelistNetJoin(struct sockaddr_in *sin, int hops, long long joinTimeNS)
+{
+    HierNodeElem *h, *oldCopy;
+    int oldHops;
+    int foundOldJoin = 0;
+    int joinIsNewer;
+
+    assert(sin);
+    /* Ignore if it's already on list and either (1) a newer record
+     * or (2) a current record and at least as close as this
+     * update.  Also ignore if it is me!
+     * For simplicity, rather than update a record in place, remove
+     * it and add a new record to front of list. This should be better
+     * for performance, too, since we expect to get a burst of
+     * notifications from all neighbors, so put record at front of list. 
+     */
+    if (!SINCMP(sin, &Config.Sockaddr.http->s)) {
+	return;
+    }
+    oldCopy = nodeFind(sin);
+    if (oldCopy != NULL) {
+	if (oldCopy->timestamp_ns > joinTimeNS) {
+	    /* We got a stale message; ignore it */
+	    return;
+	} else if (oldCopy->action != HC_Join
+	    && oldCopy->timestamp_ns < joinTimeNS) {
+	    /* Join supercedes an old HC_Leave */
+	    dlinkDelete(&oldCopy->links, &nodes);
+	    xfree(oldCopy);
+	    /* Fall through and add this join to nodelist */
+	} else {
+	    assert(oldCopy->action == HC_Join);
+	    foundOldJoin = 1;
+	    assert(oldCopy->timestamp_ns <= joinTimeNS);
+	    joinIsNewer = (oldCopy->timestamp_ns < joinTimeNS);
+	    oldHops = netdbHintHops(sin->sin_addr);
+
+
+	    if (oldHops > hops) {
+	        dlinkDelete(&oldCopy->links, &nodes);
+		xfree(oldCopy);
+		/* Fall through and add this join to nodelist and flood */
+	    } else if (joinIsNewer) {
+		/*
+		 * Join is newer but not closer. Propagate to neighbors
+		 * but no need to do anything locally beyond updating
+		 * the timestamp.
+		 */
+		oldCopy->timestamp_ns = joinTimeNS;
+		floodEvent(HC_Join, sin, joinTimeNS, hops + 1);
+		return;
+	    }
+	}
+    }
+    /*
+     * Only get here if new join supercedes and old join removed or
+     * nonexistant. Do the join and flood it to neighbors.
+     */
+    assert(!nodeFind(sin));
+
+    h = (HierNodeElem *) xmalloc(sizeof(HierNodeElem));
+    HierNodeElem_Init(h, sin, HC_Join, joinTimeNS);
+    dlinkAdd(h, &h->links, &nodes);
+
+    /*
+     * Now tell everyone else (locally and network) about 
+     * the new addition or new distance
+     */
+    floodEvent(HC_Join, sin, joinTimeNS, hops + 1);
+    if (foundOldJoin) {
+	HintCacheNodelistOutcallHops(sin, hops, joinTimeNS);
+    } else {
+	hintCacheNodelistOutcallJoin(sin, hops, joinTimeNS);
+    }
+
+    if (!foundOldJoin) {
+	debug(HCNODES_DEBUG, 2)
+	    ("hintCacheNodelist::NetJoin() adds %d.%d.%d.%d; list is: \n",
+	    (unsigned char) ((sin->sin_addr.s_addr & 0xFF000000) >> 24),
+	    (unsigned char) ((sin->sin_addr.s_addr & 0x00FF0000) >> 16),
+	    (unsigned char) ((sin->sin_addr.s_addr & 0x0000FF00) >> 8),
+	    (unsigned char) ((sin->sin_addr.s_addr & 0x000000FF) >> 0));
+	printList();
+	debug(HCNODES_DEBUG, 2) ("\n");
+    }
+
+}
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheNodelistNetLeave --
+ *
+ *          Process a notification that a node has left the system
+ *
+ *          We keep "departed" nodes on nodelist with a "leave" flag
+ *          set so we know when to stop propagating messages.
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *----------------------------------------------------7.19.1998--------------
+ */
+void
+hintCacheNodelistNetLeave(struct sockaddr_in *sin, int hops, long long leaveTimeNS)
+{
+    HierNodeElem *h, *oldCopy;
+    int foundOldLeave = 0;
+
+    assert(sin);
+
+    /* Ignore if it's already on list and a newer record.
+     * For simplicity, rather than update a record in place, remove
+     * it and add a new record to front of list. This should be better
+     * for performance, too, since we expect to get a burst of
+     * notifications from all neighbors, so put record at front of list. 
+     */
+    oldCopy = nodeFind(sin);
+    if (oldCopy) {
+	if (oldCopy->action == HC_Leave) {
+	    foundOldLeave = 1;
+	}
+	if (oldCopy->timestamp_ns < leaveTimeNS) {
+	    dlinkDelete(&oldCopy->links, &nodes);
+	    xfree(oldCopy);
+	} else {
+	    /* 
+	     * old copy is actually newer than this update. Ignore this
+	     * update.
+	     */
+	    return;
+	}
+    }
+    /*
+     * Only get here if new leave supercedes old record removed or
+     * nonexistant 
+     */
+    assert(!nodeFind(sin));
+
+    h = (HierNodeElem *) xmalloc(sizeof(HierNodeElem));
+    HierNodeElem_Init(h, sin, HC_Leave, leaveTimeNS);
+    dlinkAdd(h, &h->links, &nodes);
+
+    /*
+     * Now tell everyone else (locally and network) about 
+     * the new addition or new distance
+     */
+    floodEvent(HC_Leave, sin, leaveTimeNS, hops + 1);
+    if (!foundOldLeave) {
+	HCNodelist_OutcallLeave(sin, hops, leaveTimeNS);
+    }
+
+    if (!foundOldLeave) {
+	debug(HCNODES_DEBUG, 4)
+	    ("HCNodelist::NetLeave() removes %d.%d.%d.%d; list is: \n",
+	    (unsigned char) ((sin->sin_addr.s_addr & 0xFF000000) >> 24),
+	    (unsigned char) ((sin->sin_addr.s_addr & 0x00FF0000) >> 16),
+	    (unsigned char) ((sin->sin_addr.s_addr & 0x0000FF00) >> 8),
+	    (unsigned char) ((sin->sin_addr.s_addr & 0x000000FF) >> 0));
+	printList();
+	debug(HCNODES_DEBUG, 4) ("\n");
+    }
+}
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheNodelist_OutcallHops --
+ *
+ *          This function gets called whenever the number of hops
+ *          to a node *changes* due to network updates. This
+ *          is a good place to put function calls to modules that
+ *          care to hear about such things.
+ *
+ *          1) netdb
+ *          2) plaxton dynamic hierarchy algorithm
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *--------------------------------------------------------7.19.1998-----
+ */
+static void
+hintCacheNodelistOutcallHops(struct sockaddr_in *sin, int hops, long long timeNS)
+{
+    char name[16];
+
+    /*
+     * Tell netdb
+     */
+    strcpy(name, inet_ntoa(sin->sin_addr));
+    if (!netdbHintHops(sin->sin_addr)) {
+	netdbAdd(sin->sin_addr, name);
+    }
+    netdbUpdateHintHops(sin->sin_addr, hops);
+
+    /* 
+     * Tell plaxton algorithm
+     */
+    hintCachePlax_changeDistance(sin);
+}
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheNodelistOutcallJoin --
+ *
+ *          This function gets called whenever a node joins the
+ *          sytsem.
+ *          This is a good place to put function calls to modules that
+ *          care to hear about such things.
+ *
+ *          Right now, 3 people care:
+ *          1) netdb
+ *          2) plaxton dynamic hierarchy algorithm
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *-------------------------------------------------7.19.1998-----------
+ */
+static void
+hintCacheNodelistOutcallJoin(struct sockaddr_in *sin, int hops, long long timeNS)
+{
+    char name[16];
+
+    /*
+     * Tell netdb
+     */
+    strcpy(name, inet_ntoa(sin->sin_addr));
+    netdbAdd(sin->sin_addr, name);
+    netdbUpdateHintHops(sin->sin_addr, hops);
+
+    /* 
+     * Tell plaxton algorithm
+     */
+    hintCachePlax_addNode(sin);
+}
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheNodelistOutcallLeave --
+ *
+ *          This function gets called whenever a node leaves the
+ *          sytsem.
+ *          This is a good place to put function calls to modules that
+ *          care to hear about such things.
+ *
+ *          1) plaxton dynamic hierarchy algorithm
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *-----------------------------------------------------7.19.1998----------
+ */
+static void
+hintCacheNodelistOutcallLeave(struct sockaddr_in *sin, int hops, long long timeNS)
+{
+    /* 
+     * Tell plaxton algorithm
+     */
+    hintCachePlax_removeNode(sin);
+}
+
+
+/*
+ *------------------------------------------------------------------
+ *
+ * nodeFind --
+ *
+ *          Find node with matching address.
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *------------------------------------------------------------------
+ */
+static HierNodeElem *
+nodeFind(struct sockaddr_in *sin)
+{
+    HierNodeElem *e;
+    dlink_node *item;
+
+    for (item = nodes.head; item; item = item->next) {
+	e = (HierNodeElem *) item;
+	if (!SINCMP(&e->sin, sin)) {
+	    return (e);
+	}
+    }
+    return (NULL);
+}
+
+/*
+ *------------------------------------------------------------------
+ *
+ * floodEvent --
+ *
+ *          Send the notification to our neighbors.
+ *
+ * Arguments:
+ *      int action HC_Join or HC_Leave
+ *      struct sockaddr_in *source -- the subject of the action
+ *      long long timeNS -- the time of the action (used for
+ *                          ordering events and removing duplicates)
+ *      int hopcount -- how many hops has this event seen?
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *-------------------------------------------------3.31.1998--------
+ */
+static void
+floodEvent(int action, struct sockaddr_in *source, long long timeNS,
+    int hopcount)
+{
+#ifdef USE_DYNAMIC_HIERARCHY
+    HintCacheEntry entry;
+    peer *p;
+    URLKey hackURLKey;
+    struct sockaddr_in dest;
+
+    assert(action == HC_Join || action == HC_Leave);
+
+    if (neighborsOutgoing == NULL) {
+	return;
+    }
+
+    hackURLKey.key = timeNS;	/* XXX Update should be a union XXX */
+
+    hintCacheEntry_Init(&entry, hackURLKey, source);
+    hintCacheNet_Enqueue(neighborsOutgoing, action, &entry, hopcount);
+#if 1
+    hintCacheNet_Complete(neighborsOutgoing);
+
+    for (p = getFirstPeer(); p; p = getNextPeer(p)) {
+	if (p->in_addr.sin_addr.s_addr == 0) {
+	    debug(HCNODES_DEBUG, 4)
+		("hintCacheNodelist warning: peer %s addr not set\n", p->host);
+	    continue;
+	}
+	dest.sin_family = AF_INET;
+	dest.sin_addr = p->in_addr.sin_addr;
+	dest.sin_port = p->http_port;
+	hintCacheNet_SendTo(neighborsOutgoing, &dest);
+    }
+
+    hintCacheNet_Done(neighborsOutgoing);
+#endif
+#endif /* USE_DYNAMIC_HIERARCHY */
+}
+
+
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheNodeListIterXXX --
+ *
+ *          Used for iterating through all addresses on list.
+ *
+ *   for(hintCacheNodeListIterStart(&iter);
+ *       hintCacheNodeListIterCheck(&iter);
+ *       hintCacheNodeListIterNext(&iter)){
+ *     valid = hintCacheNOdeListIterGetAddr(&iter, &addr);
+ *   }
+ *  
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      Note -- only itereates through "joined" elements;
+ *      Skip the shadow elements representing nodes that
+ *      have left.
+ *
+ *      Warning -- iterator is pointer into element on list.
+ *      If list changing during iteration, could get confused.
+ *
+ *------------------------------------------------------------------
+ */
+void
+hintCacheNodeListIterStart(HintCacheNodeListIter iter)
+{
+    iter = (HintCacheNodeListIter) nodes.head;
+}
+
+int
+hintCacheNodeList_IterCheck(HintCacheNodeListIter iter)
+{
+    dlink_node *links = iter;
+    return (links->next != 0);
+}
+
+void
+hintCacheNodeList_IterNext(HintCacheNodeListIter iter)
+{
+    HierNodeElem *elem;
+
+    if (iter->next == 0) {
+	return;
+    }
+
+    while (1) {
+	iter = iter->next;
+	/*
+	 * Skip non-HC_Join elements by keeping going in that case.
+	 */
+	if (iter->next == 0) {
+	    return;
+	}
+	elem = iter->data;
+	if (elem->action == HC_Join) {
+	    return;
+	}
+    }
+
+}
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheNodelistIterGetAddr --
+ *
+ *          description.
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *------------------------------------------------------------------
+ */
+int
+hintCacheNodelistIterGetAddr(HintCacheNodeListIter iter, struct sockaddr_in *ret)
+{
+    HierNodeElem *elem;
+    elem = iter->data;
+    *ret = elem->sin;
+    if (elem->action == HC_Join) {
+	return 1;
+    }
+    return 0;
+}
+
+
+/*
+ *------------------------------------------------------------------
+ *
+ * currentTimeNS --
+ *
+ *          Return the current time in nanoseconds since Jan 1, 1970.
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *------------------------------------------------------------------
+ */
+static long long
+currentTimeNS()
+{
+    static const long long NS_PER_SEC = 1000000000;
+    static const long long NS_PER_USEC = 1000;
+    int error;
+    struct timeval time;
+    long long ret;
+
+    error = gettimeofday(&time, NULL);
+    assert(error != -1);
+    ret = NS_PER_SEC * (long long) time.tv_sec
+	+ NS_PER_USEC * (long long) time.tv_usec;
+    return ret;
+}
+
+/*
+ *------------------------------------------------------------------
+ *
+ * printList --
+ *
+ *          Print the current list of nodes to stdout.
+ *
+ * Arguments:
+ *      None.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+
+ *------------------------------------------------------------------
+ */
+static void
+printList()
+{
+    HintCacheNodeListIter iter;
+    struct sockaddr_in nodeAddr;
+    int valid;
+
+    for (hintCacheNodeListIterStart(iter);
+	hintCacheNodeListIterCheck(iter); hintCacheNodeListIterNext(&iter)) {
+	valid = hintCacheNodeListIterGetAddr(iter, &nodeAddr);
+	if (valid) {
+	    debug(HCNODES_DEBUG, 2)
+		("\t%d.%d.%d.%d\n",
+		(unsigned char) ((nodeAddr.sin_addr.s_addr & 0xFF000000) >> 24),
+		(unsigned char) ((nodeAddr.sin_addr.s_addr & 0x00FF0000) >> 16),
+		(unsigned char) ((nodeAddr.sin_addr.s_addr & 0x0000FF00) >> 8),
+		(unsigned char) ((nodeAddr.sin_addr.s_addr & 0x000000FF) >> 0));
+	}
+    }
+}
+
+
+#ifdef DOTEST
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheNodelistSelfTest --
+ *
+ *          description.
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *------------------------------------------------------------------
+ */
+void
+hintCacheNodelistSelfTest(void)
+{
+    struct sockaddr_in n0, n1, n2;
+    HintCacheNodeListIter iter;
+    struct sockaddr_in nodeAddr;
+    int nhops;
+    int valid;
+    int found = 0;
+
+    printf("HintCacheNodelistSelfTest...");
+    n0.sin_addr.s_addr = 0x90536F00;
+    n0.sin_port = 0;
+    n1.sin_addr.s_addr = 0x91536F01;
+    n1.sin_port = 1;
+    n2.sin_addr.s_addr = 0x92536F02;
+    n2.sin_port = 2;
+
+    hintCacheNodelistInit();
+    hintCachePlax_Init(8);
+
+    assert(neighborsOutgoing == NULL);
+    neighborsOutgoing = (HintCacheNet *) xmalloc(sizeof(HintCacheNet));
+    assert(neighborsOutgoing);
+    hintCacheNet_Init(neighborsOutgoing);
+    hintCacheNet_SetTestMode(neighborsOutgoing);
+
+
+    /*
+     * How to test if this really works? For now look at how many
+     * outgoing messages were enqueued.
+     */
+    hintCacheNodelistLocalJoin();
+    hintCacheNodelistLocalLeave();
+    assert(hintCacheNet_GetTestCount(neighborsOutgoing) == 2);
+
+    /*
+     * Expected final state:
+     * n0 JOIN dist = 12
+     * n1 LEAVE XXX
+     * n2 JOIN dist=20
+     */
+    hintCacheNodelistNetJoin(&n0, 10, 42);
+    hintCacheNodelistNetJoin(&n2, 20, 42);
+    hintCacheNodelistNetJoin(&n0, 13, 43);
+    hintCacheNodelistNetJoin(&n1, 20, 42);
+    hintCacheNodelistNetJoin(&n2, 20, 100);
+    hintCacheNodelistNetJoin(&n0, 9, 42);
+    hintCacheNodelistNetJoin(&n0, 12, 43);
+    hintCacheNodelistNetJoin(&n2, 20, 42);
+    hintCacheNodelistNetLeave(&n1, 999, 43);
+    hintCacheNodelistNetJoin(&n1, 19, 42);
+
+    for (hintCacheNodeListIterStart(&iter);
+	hintCacheNodeListIterCheck(iter); hintCacheNodeList_IterNext(&iter)) {
+	valid = hintCacheNodeListIterGetAddr(iter, &nodeAddr);
+	if (valid) {
+	    nhops = netdbHintHops(nodeAddr.sin_addr);
+	    if (nodeAddr.sin_addr.s_addr == n0.sin_addr.s_addr) {
+		found++;
+		assert(nhops == 12);
+	    }
+	    if (nodeAddr.sin_addr.s_addr == n2.sin_addr.s_addr) {
+		found++;
+		assert(nhops = 20);
+	    }
+	    if (nodeAddr.sin_addr.s_addr == n1.sin_addr.s_addr) {
+		assert(0);
+	    }
+	}
+    }
+    assert(found == 2);
+
+    hintCacheNodelistDestroy();
+    hintCachePlaxDestroy();
+
+    hintCacheNetDestroy(neighborsOutgoing);
+    free(neighborsOutgoing);
+    neighborsOutgoing = NULL;
+
+    printf("..OK\n");
+
+}
+
+#endif /* DOTEST */
